!define PRODUCT_NAME "Servidor OPC UA para USB-1408FS-Plus"
!define PRODUCT_VERSION ""
!define PRODUCT_PUBLISHER "Oscar Emilio Aponte Rengifo - Jess M. Zamarreo"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\Servidor OPC UA para USB-1408FS-Plus.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\classic-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\classic-uninstall.ico"

; Language Selection Dialog Settings
!define MUI_LANGDLL_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_LANGDLL_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_LANGDLL_REGISTRY_VALUENAME "NSIS:Language"

; Welcome page
!define MUI_WELCOMEPAGE_TITLE_3LINES
!insertmacro MUI_PAGE_WELCOME
; Directory page
!insertmacro MUI_PAGE_DIRECTORY
; Instfiles page
!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_TITLE_3LINES
!define MUI_FINISHPAGE_RUN "$INSTDIR\Servidor OPC UA para USB-1408FS-Plus.exe"
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "Spanish"

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "..\Servidor OPC UA para USB-1408FS-Plus.exe"
InstallDir "$PROGRAMFILES\Servidor OPC UA para USB-1408FS-Plus"
ShowInstDetails show
ShowUnInstDetails show

Section "Principal" SEC01
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  File "OPC_UA_Server_USB_1408FS-Plus.exe"
  CreateDirectory "$INSTDIR"
SectionEnd

Section -AdditionalIcons
  CreateDirectory "$SMPROGRAMS\Servidor OPC UA para USB-1408FS-Plus"
  CreateShortCut "$SMPROGRAMS\Servidor OPC UA para USB-1408FS-Plus\Desinstalar.lnk" "$INSTDIR\uninst.exe"
  CreateShortCut "$SMPROGRAMS\Servidor OPC UA para USB-1408FS-Plus\Servidor OPC UA para USB-1408FS-Plus.lnk" "$INSTDIR\Servidor OPC UA para USB-1408FS-Plus.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\Servidor OPC UA para USB-1408FS-Plus.exe"
SectionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "Desinstalacin completada con xito."
FunctionEnd

Function un.onInit
!insertmacro MUI_UNGETLANGUAGE
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Est completamente seguro de que desea desinstalar $(^Name) y la totalidad de los componentes de la misma?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  Delete "$INSTDIR\Servidor OPC UA para USB-1408FS-Plus.exe"
  Delete "$INSTDIR\uninst.exe"
  RMDir "$INSTDIR"

  Delete "$SMPROGRAMS\Servidor OPC UA para USB-1408FS-Plus\Desinstalar.lnk"
  Delete "$SMPROGRAMS\Servidor OPC UA para USB-1408FS-Plus\Servidor OPC UA para USB-1408FS-Plus.lnk"

  RMDir "$SMPROGRAMS\Servidor OPC UA para USB-1408FS-Plus"

  DeleteRegKey "${PRODUCT_UNINST_ROOT_KEY}" "${PRODUCT_UNINST_KEY}"
  SetAutoClose true
SectionEnd
