/*
        Universidad de Valladolid - Escuela de Ingenierias Industriales
            Grado en Electrnica Indutrial y Automtica
            Trabajo de fin de grado
            Alumno: Oscar Emilio Aponte Rengifo
            Tutor: Jess Mara Zamarreo Cosme


        Desarrollo de un Servidor OPC UA para una tarjeta de adquisicin de datos USB-1408FS-Plus
        tarjeta_1408FS.c
*/

#include "tarjeta_1408FS.h"

int configuracion_modo(){
    int ConfigVal;
    if(cbGetConfig(BOARDINFO,get_tarjeta_en_uso(),NOTUSED,BINUMADCHANS, &ConfigVal)!=NOERRORS)
    UA_LOG_INFO(UA_Log_Stdout, UA_LOGCATEGORY_SERVER,"\n \n Error en la configuracin Diferencial/Comn");

    return ConfigVal;
}

/********************* Entradas analgicas ***********************/
int get_tarjeta_en_uso(){
    return(tarjeta_en_uso);
}

bool setRange(int wChannel, int wConfCode)
{
	unsigned short valor;
	if(cbSetConfig(BOARDINFO,get_tarjeta_en_uso(),NOTUSED,BIRANGE,wConfCode)!=NOERRORS)
    {printf("NO SE HA PODIDO CAMBIAR EL RANGO");
        return(false);}
    else
    printf("\n\n CORRECTO ENVIO DEL RANGO");

	if (cbAIn(get_tarjeta_en_uso(),0,BIP5VOLTS,&valor)!=NOERRORS) /* Lee el canal analogico de entrada */
		return(false);
	else
		return(true);
}

bool selecciona_Range(int channel,float rang)
{
    /* (+-) 20 10 5 4 2.5 2 1.25 1v */
    /* BIP20VOLTS BIP10VOLTS  BIP5VOLTS BIP4VOLTS BIP2PT5VOLTS BIP2VOLTS BIP1PT25VOLTS BIP1VOLTS*/
    int wConfcode;
    bool rango_correcto=true;
    if (rang == 20)
        wConfcode = BIP20VOLTS;
    if(rang ==10)
        wConfcode = BIP10VOLTS;
     if(rang ==5)
        wConfcode = BIP5VOLTS;
     if(rang ==4)
        wConfcode = BIP4VOLTS;
     if(rang ==2.5)
        wConfcode = BIP2PT5VOLTS;
     if(rang ==2)
        wConfcode = BIP2VOLTS;
     if(rang ==1.25)
        wConfcode = BIP1PT25VOLTS;
     if(rang ==1)
        wConfcode = BIP1VOLTS;
     if(rang !=20 && rang !=10 && rang !=5 && rang !=4 && rang !=2.5 && rang !=2 && rang !=1.25 && rang !=1)
        {
        wConfcode = BIP5VOLTS;
        rango_correcto=false;
        }
    setRange(channel,wConfcode);
    return (rango_correcto);
}


WORD getRange(int wChannel)
{
	return(In[wChannel].Range);
}

float get_In_volts(int wChannel)
{
	unsigned short DataVal;
	float Voltage;

	if (cbAIn(get_tarjeta_en_uso(),wChannel,In[wChannel].Range,&DataVal)==NOERRORS)
		{cbToEngUnits (get_tarjeta_en_uso(),In[wChannel].Range,DataVal,&Voltage);
		 In[wChannel].value=Voltage;}

    return(In[wChannel].value);

}
unsigned int get_In_bin(int wChannel)
{
	unsigned short DataVal;

	if (cbAIn(get_tarjeta_en_uso(),wChannel,In[wChannel].Range,&DataVal)==NOERRORS) /* Lee del canal analogico de entrada */
		In[wChannel].value=DataVal;

	return(In[wChannel].value);
}
void init_entradas()
{
    int i;
    bool exito=true;
	for (i=0;i<8;i++)
	{
	    In[i].Range = BIP5VOLTS; // asigna los rangos de las 8 entradas analogicas
		if (cbSetConfig(BOARDINFO,get_tarjeta_en_uso(),NOTUSED,BIRANGE,In[i].Range)!=NOERRORS)
        exito=false;
    }
	printf("\n ENTRADAS ANALOGICAS INICIALIZADAS [%d]\n",exito);
}


/********************* Salidas analgicas ***********************/

bool set_Out(int wChannel, int wOut)
{
	bool exito=true;

	if 	(cbAOut(get_tarjeta_en_uso(),wChannel,UNI5VOLTS,wOut)!=NOERRORS)
		exito=false;
	else
		Out[wChannel]=wOut;
	return(exito);
}

bool set_Out_porcent(int wChannel,float porcentaje)
{
	bool exito=true;
	int Temp;
	div_t result;
    MaximoNumeroAnalogicoOut = 4095;
	result=div(porcentaje*MaximoNumeroAnalogicoOut,100);
	Temp=result.quot;
	if(result.rem >0)
		Temp++;
	if (cbAOut(tarjeta_en_uso,wChannel,UNI5VOLTS,Temp)!=NOERRORS)
			exito=false;
	else
    Out[wChannel]=Temp;
    UA_LOG_INFO(UA_Log_Stdout, UA_LOGCATEGORY_SERVER, "set out porcent [%d]",Temp);
	return(exito);
}//

bool set_Out_Volts(int wChannel, float voltios)
{
    tarjeta_en_uso = 0;
	bool exito=true;
	unsigned short DataVal;

	cbFromEngUnits (get_tarjeta_en_uso(),UNI5VOLTS,voltios,&DataVal);
	if(cbAOut(tarjeta_en_uso,wChannel,UNI5VOLTS,DataVal)!=NOERRORS)
		exito=false;
	else
    Out[wChannel]=voltios*(4095/5);

	return(exito);
}

float get_Out_porcent(int wChannel)
{
     MaximoNumeroAnalogicoOut = 4095;
	if (Out[wChannel]!=0) //divison por cero se evita
		return((float)(Out[wChannel]*100)/MaximoNumeroAnalogicoOut);
	else
		return(0);
}//


float get_Out_Volts(int wChannel)
{
    MaximoNumeroAnalogicoOut = 4095;
	if (Out[wChannel]!=0) //division por cero se evita
		return((float)(Out[wChannel]*5)/MaximoNumeroAnalogicoOut);
	else
		return(0);
}
int get_Out(int wChannel)
{
	return(Out[wChannel]);
}

void init_salidas()
{
	//salidas
	bool exito = true;
	unsigned int i;
	for (i=0;i<2;i++)
	{
		Out[i]=0;
		if (cbAOut(tarjeta_en_uso,i,UNI5VOLTS,Out[i])!=NOERRORS)
			exito=false;
	}

	printf("\n SALIDAS ANALOGICAS INICIALIZADAS [%d]\n",exito);
}

void ini_tarjeta()
{
    int BoardsInstalled=0;
    int TotalBoard=0;
	int Tipo;
	int boardnum;
	int pmd;
	unsigned short valor;
	bool encontrado =false;
	bool error=false;
	bool tar_encontrada=true;
    char *BoardName;

    printf("\n \n --------------- INICIALIZACION DE LA TARJETA ---------------------- \n");

    if (cbGetConfig (GLOBALINFO, 0, 0, GINUMBOARDS, &TotalBoard)!=NOERRORS)
        printf("\n \n Error en la comunicacin con la tarjeta.\nCompruebe la configuracin con Instacal.");

        printf("\n \n Numero maximo de tarjetas que pueden ser instaladas [%d]",TotalBoard);

        while (!encontrado)
        {
            cbGetConfig(BOARDINFO,BoardsInstalled,NOTUSED,BIBOARDTYPE,&Tipo);
            printf("\n \n Tipo de tarjeta encontrada [%d]",Tipo);

                if (Tipo==233)
                {
                    printf("\n \n Tarjeta 1408FS-Plus encontrada ");
                    printf("\n \n Id en Instacall  [%d]",BoardsInstalled);
                    tarjeta_en_uso = BoardsInstalled;
                    encontrado=true;
                }
                BoardsInstalled++;

        }
        printf("\n \n TARJETA USB-1408FS-PLUS [%d] \n",encontrado);
}

/******************************** Puertos Digitales ***********************************/

void set_digmode_AIN()
{//configura el puerto A para entrada
	cbDConfigPort(get_tarjeta_en_uso(),FIRSTPORTA,DIGITALIN);
	modoA=0;
}//

void set_digmode_AOUT()
{//configura el puerto A para salida
	cbDConfigPort(get_tarjeta_en_uso(),FIRSTPORTA,DIGITALOUT);
	modoA=1;
}//


void set_digmode_BIN()
{//configura el puerto B para entrada
	cbDConfigPort(get_tarjeta_en_uso(),FIRSTPORTB,DIGITALIN);
	modoB=0;
}//


void set_digmode_BOUT()
{//configura el puerto B para salida
	cbDConfigPort(get_tarjeta_en_uso(),FIRSTPORTB,DIGITALOUT);
	modoB=1;
}//


int get_digmode()
{//obtiene la configuracin del puerto digital
	if((modoA==0) && (modoB==0))
		return(1);
	if((modoA==1) && (modoB==1))
		return(2);
	if((modoA==0) && (modoB==1))
		return(3);
	if((modoA==1) && (modoB==0))
		return(4);
}//

int get_digmode_a()
{
    return (modoA);
}

int get_digmode_b()
{
    return (modoB);
}

bool get_modo_AOUT()
{//TRUE si se escribi en el puerto A
	return(PuertoA);
}//

bool get_modo_BOUT()
{//TRUE si se escribi en el puerto B
	return(PuertoB);
}//

void set_modo_AOUT(bool mod)
{
	PuertoA=mod;
}//


void set_modo_BOUT(bool mod)
{
	PuertoB=mod;
}//


bool set_bit_Do_A(int bit, int value)
{
	bool success=true;
	if(cbDBitOut(get_tarjeta_en_uso(),FIRSTPORTA,bit,value)!=NOERRORS)
    success=false;
  //  UA_LOG_INFO(UA_Log_Stdout, UA_LOGCATEGORY_SERVER, "\n\n set_bit_Do_A [%d]\n\n",value);
	return(success);
}//

bool set_bit_Do_B(int bit, int value)
{
	bool success=true;
	if(cbDBitOut(tarjeta_en_uso,FIRSTPORTB,bit,value)!=NOERRORS)
    success=false;
 //   UA_LOG_INFO(UA_Log_Stdout, UA_LOGCATEGORY_SERVER, "\n\n set_bit_Do_B [%d]\n\n",value_bool);
    return(success);
}//

bool get_bit_Do(int bit)
{
	WORD Result,Mask;
	unsigned short salida;
	Result=Do;
	//Necesitamos poner un '1' en el bit correcto.
	Mask=0x0001;
	Mask =Mask << bit;
	Result=(Mask & Result);
	//Si Result es 0 ahora, entonces se leyo un 0 en aquella posicion.
	cbDBitIn(tarjeta_en_uso,FIRSTPORTA,bit,&salida);
	if ((Result!= 0x0000) || (salida!=0))
		return(true);
	else
		return(false);
}//

/* Lee el bit individual (uno a uno: ejemplo: Puerto_A_bit_2) */
int get_bit_Di_A(unsigned int bit)
{
	unsigned short salida;
	int exito=0;

    if(cbDBitIn(get_tarjeta_en_uso(),FIRSTPORTA,bit,&salida)!=NOERRORS)
    UA_LOG_INFO(UA_Log_Stdout, UA_LOGCATEGORY_SERVER, "\n\n------ ERROR");

    UA_LOG_INFO(UA_Log_Stdout, UA_LOGCATEGORY_SERVER, "\n\n------ get_bit_Di_A  [%d] \n\n ",salida);
   if (salida==0)
   exito=0;
	else
    exito=1;

	return(exito);
}//
int get_bit_Di_B(unsigned int bit)
{
	unsigned short salida;
	int exito=0;

    if(cbDBitIn(get_tarjeta_en_uso(),FIRSTPORTB,bit,&salida)!=NOERRORS)
    UA_LOG_INFO(UA_Log_Stdout, UA_LOGCATEGORY_SERVER, "\n\n------ ERROR");

    UA_LOG_INFO(UA_Log_Stdout, UA_LOGCATEGORY_SERVER, "\n\n------ get_bit_Di_B  [%d] \n\n ",salida);
   if (salida==0)
   exito=0;
	else
    exito=1;

	return(exito);
}//


bool set_Do(WORD wDo)
{
	bool exito=true;

	if (cbDOut(tarjeta_en_uso,FIRSTPORTA,wDo)!=NOERRORS)
	{
		exito=false;
		Do=-1;
	}
	else
		Do=wDo;

	return(exito);
}//


WORD get_Do()
{
	unsigned short salida;
	int resultado=0;
	int parcial=0;

	if(get_digmode()==2)
		for(int i=0;i<16;i++)
		{
			cbDBitIn(tarjeta_en_uso,FIRSTPORTA,i,&salida);
			if (salida==1)
				parcial=pow(2,i);
			else
				parcial=0;
			resultado=resultado+parcial;
		}
	if(get_digmode()==1)
		resultado=0;
	if(get_digmode()==4)
		for(int i=0;i<8;i++)
		{
			cbDBitIn(tarjeta_en_uso,FIRSTPORTA,i,&salida);
			if (salida==1)
				parcial=pow(2,i);
			else
				parcial=0;
			resultado=resultado+parcial;
		}
	if(get_digmode()==3)
		for(int i=8;i<16;i++)
		{
			cbDBitIn(tarjeta_en_uso,FIRSTPORTA,i,&salida);
			if (salida==1)
				parcial=pow(2,i-8);
			else
				parcial=0;
			resultado=resultado+parcial;
		}
	Do=resultado;

	return(Do);
}//


int init_digitales()
{
    unsigned int i;
	bool exito=true;

    unsigned short Valor;

	PuertoA=false;
	PuertoB=false;
	Do=0x0000;

	//digitales
	set_digmode_AOUT();
	set_digmode_BOUT();
	if ((cbDOut(get_tarjeta_en_uso(),FIRSTPORTA,0) || cbDOut(get_tarjeta_en_uso(),FIRSTPORTB,0))!=NOERRORS)
    exito=false;

	set_digmode_AIN();
	set_digmode_BIN();
	if ((cbDIn(get_tarjeta_en_uso(),FIRSTPORTA,&Valor) || cbDIn(get_tarjeta_en_uso(),FIRSTPORTB,&Valor))!=NOERRORS)
		exito=false;

    printf("\n PUERTOS DIGITALES INICIALIZADOS [%d] \n \n \n",exito);

    return exito;
}
